unit uFooList;
interface
uses
  Generics.Collections;
type

  TFooList <T>= class(TList<T>)
  private
    procedure FreeAllItems;
  protected
    procedure FreeItem(Item: T);virtual;
    // Ҫش˹̡ȷͷ Item
    //  Item ָ룬 Dispose(Item);
    //  Item TObject  Item.free;
  public
    destructor Destroy;override;
    procedure ClearAllItems;
    procedure Lock;  // һ
    procedure Unlock;
  end;
  // 뵽 List  Item  List ͷš
  // ͷŹҪֻйˣŲס
  // ͨ򵥵ĸĿ TList  N 

implementation
{ TFooList<T> }

procedure TFooList<T>.ClearAllItems;
begin
  FreeAllItems;
  Clear;
end;

destructor TFooList<T>.Destroy;
begin
  FreeAllItems;
  inherited;
end;

procedure TFooList<T>.FreeAllItems;
var
  Item: T;
begin
  for Item in self do
    FreeItem(Item);
end;

procedure TFooList<T>.FreeItem(Item: T);
begin
end;

procedure TFooList<T>.Lock;
begin
  System.TMonitor.Enter(self);
end;

procedure TFooList<T>.Unlock;
begin
  System.TMonitor.Exit(self);
end;

end.
