unit uFooThread;

interface

uses
  System.Classes, System.SyncObjs;

type

  TOnMsg = procedure(AMsg: string) of object; // һϢ¼

  // ܶƼ String ǰ const Ч
  // ҵΪ˴ۡж const ̫ˡ
  // ԺʹУԼǷ const 
  TFooThread = class(TThread)
  private
    FEvent: TEvent;
    FCanAccessCom: Boolean;
    FRunningInThread: TThreadMethod;
    // TThreadMethod Ķ TThreadMethod = Procedure of object;
    // Ϊ Procedure дһеġ
    // УTThreadMethod Ϊָ롣
    // FRunningInThread 潫Ҫ߳еĴ Procedure
    procedure DoExecute;
  protected
    // protected жı뺯еá
    procedure Execute; override;
    procedure DoOnStatusMsg(AMsg: string);
    procedure ExecProcInThread(AProc: TThreadMethod);
  public
    constructor Create(ACanAccessCOM: Boolean); reintroduce;
    // reintroduce  Create Ĳ˼
    destructor Destroy; override;
    procedure StartThread; virtual;
  public
    OnStatusMsg: TOnMsg;
    // ɸдΪ Property OnStatusMsg:TOnMsg Read FOnMsg write SetOnMsg;
    // ̫ˣٶ SetOnMsg вд
    // ҪĶԭĴԲ䡣
  end;
  // δ˵֮οƻ֪ʶ

implementation

uses ActiveX, SysUtils;

constructor TFooThread.Create(ACanAccessCOM: Boolean);
begin
  inherited Create(false);
  FEvent := TEvent.Create(nil, true, false, '');
  FreeOnTerminate := false;
end;

destructor TFooThread.Destroy;
begin
  // ˴Ҫֶ Free ĵá
  Terminate; // Ҫ Terminated Ϊ true;
  FEvent.SetEvent; // ̡߳
  WaitFor; //  waitfor ˼ǵȴ߳˳ Execute
  //  WaitFor  TThread ġע FEvent.WaitFor 
  // ϣǶǲϵͳṩźŵĵȴܡ
  // ȤֱӲοϵͳԴ ( delphi ṩԴ )
  FEvent.Free;
  inherited;
end;

procedure TFooThread.DoExecute;
begin
  FEvent.WaitFor;
  FEvent.ResetEvent;
  while not Terminated do
  begin

    try
      FRunningInThread; // Ϊһ Procedure ʿֱС
    except
      // ׽쳣쳣ʱ뽫˳ Execute ߳ھͽˡ
      on e: Exception do
      begin
        DoOnStatusMsg('ThreadErr:' + e.Message);
      end;
    end;

    FEvent.WaitFor;
    FEvent.ResetEvent;

  end;
end;

procedure TFooThread.DoOnStatusMsg(AMsg: string);
begin
  // ¼õд
  if Assigned(OnStatusMsg) then
    OnStatusMsg(AMsg);
end;

procedure TFooThread.ExecProcInThread(AProc: TThreadMethod);
begin
  FRunningInThread := AProc;
  FEvent.SetEvent; // ̡߳
  // Ҫ˵ǣһб ExecProcInThread һ߳ʱС
  // ڶбڱ߳ʱС
  // ǰ AProc ߳ʱв̡߳
end;

procedure TFooThread.Execute;
begin

  if FCanAccessCom then
  begin
    CoInitialize(nil);
    // ߳гʼ COM ˴˾䣬߳ʹ COM
    //  windows ϵͳ涨ģ delphi ûйϵ
    //  api ̣߳߳з COM ͬҪ
    try
      DoExecute;
    finally
      CoUninitialize; // ʼӦ̷߳ COM 
    end;
  end
  else
    DoExecute;

end;

procedure TFooThread.StartThread;
begin
end;

end.
